// test.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include "ET199_32.h"

#pragma comment(lib, "ET199_32S.lib")

int main(int argc, char* argv[])
{
	
	////////////////////////////////////ʹ˽ԿET199нup_0001_cipher.binн////////////////////////////
	
	//Ƚup_0001_cipher.binȡڴ
	BYTE* pbCipherBINData = NULL;
	FILE* fp = NULL;
	long fileLen = 0;
	fp = fopen("up_0001_cipher.bin","rb");
	if(fp == NULL)
		exit(110);
	fseek(fp, SEEK_SET, SEEK_END);
	fileLen = ftell(fp);
	pbCipherBINData = new BYTE[fileLen];
	memset(pbCipherBINData, 0, fileLen);
	fseek(fp, SEEK_SET, SEEK_SET);
	fread(pbCipherBINData, sizeof(BYTE), fileLen, fp);
	fclose(fp);
	
		
	DWORD dwRet;
	DWORD dwCount=0;
	ET_CONTEXT *pContext;

	BYTE pbOut[128] = {0};
	DWORD dwOutLen = 0;

	//öET199
	dwRet=ETEnum(NULL,&dwCount);

	if(dwRet != ET_E_INSUFFICIENT_BUFFER && dwRet)
		return dwRet;

	//ڴڴ洢CONTEXTṹ
	pContext = new ET_CONTEXT[dwCount];

	//0
	memset(pContext,0,sizeof(ET_CONTEXT)*dwCount);

	//ʹ÷Ļ½ö
	dwRet=ETEnum(pContext,&dwCount);
	if(dwRet)
		return dwRet;

	//printf("Find ET199 %d\n",dwCount);

	//ET199
	dwRet = ETOpen(&pContext[0]);
	if(dwRet)
		return dwRet;

	//ִгǰҪ֤û
	dwRet = ETVerifyPin(&pContext[0], ET_DEFAULT_USER_PIN, ET_USER_PIN_LEN, ET_USER_PIN);
	if(dwRet)
	{
		printf("ETVerifyPin Error:0x%08X\n",dwRet);
		ETClose(&pContext[0]);
		delete [] pContext;
		return dwRet;
	}
	
	int iBlock = fileLen/128;
	int iLen = 0;
	BYTE pbIN[129] = {0};

	for(int i=0; i<iBlock; ++i)
	{
		//
		//һֽǿ
		//128ֽڵ
		memset(pbIN, 0, 129);
		
		pbIN[0] = i;
		memcpy(pbIN+1, pbCipherBINData+128*i, 128);

		//ļup.cļIDΪ0002
		dwRet = ETExecute(&pContext[0],"0002",pbIN,129,pbOut,128, &dwOutLen);
		if(dwRet)
		{
			printf("ETExecute Error 1:0x%08X\n",dwRet);
			ETClose(&pContext[0]);
			delete [] pContext;
			return dwRet;
		}

		//ֵΪ1߷ֵΪ0
		if((dwOutLen != 1) || (pbOut[0] != 0))
		{
			printf("ETExecute Error 2:0x%08X\n",pbOut[0]);
			ETClose(&pContext[0]);
			delete [] pContext;
			return dwRet;
		}		
	}


	printf("Update Sucess!\n");

	ETClose(&pContext[0]);
	delete [] pContext;
	
	return 0;
}
