// test.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include <stdio.h>
#include "ET199_32.h"

#pragma comment(lib, "ET199_32S.lib")

void FlipBuffer(unsigned char* pBuf, unsigned long ulLen)
{
	unsigned char ucTemp;
	for(unsigned long i = 0; i < ulLen >> 1; ++i)
	{
		ucTemp = pBuf[i];
		pBuf[i] = pBuf[ulLen - i - 1];
		pBuf[ulLen - i - 1] = ucTemp;
	}
}

int main(int argc, char* argv[])
{
	
	
	DWORD dwRet;
	DWORD dwCount=0;
	ET_CONTEXT *pContext;

	BYTE pbOut[256] = {0};
	BYTE pbIN[256] = {0};
	DWORD dwOutLen = 0;
	DWORD dwOut = 0;
	
	//öET199
	dwRet=ETEnum(NULL,&dwCount);

	if(dwRet != ET_E_INSUFFICIENT_BUFFER && dwRet)
		return dwRet;

	//ڴڴ洢CONTEXTṹ
	pContext = new ET_CONTEXT[dwCount];

	//0
	memset(pContext,0,sizeof(ET_CONTEXT)*dwCount);

	//ʹ÷Ļ½ö
	dwRet=ETEnum(pContext,&dwCount);
	if(dwRet)
		return dwRet;

	//printf("Find ET199 %d\n",dwCount);

	//ET199
	dwRet = ETOpen(&pContext[0]);
	if(dwRet)
		return dwRet;

	
	//ִгǰҪ֤û
	dwRet = ETVerifyPin(&pContext[0], ET_DEFAULT_USER_PIN, ET_USER_PIN_LEN, ET_USER_PIN);
	if(dwRet)
	{
		printf("ETVerifyPin Error:0x%08X\n",dwRet);
		delete [] pContext;
		return dwRet;
	}

	//C51еintΪ2ֽڣshortC51Ҫ
	short i =5, j=8, res=0;
	FlipBuffer((unsigned char*)&i, 2);
	FlipBuffer((unsigned char*)&j, 2);

	memcpy(pbIN, &i, 2);
	memcpy(pbIN+2, &j, 2);


	dwRet = ETExecute(&pContext[0],"0001",pbIN,4,pbOut,256, &dwOutLen);
	if(dwRet)
	{
		printf("ETExecute Error 1:0x%08X\n",dwRet);
		delete [] pContext;
		return dwRet;
	}

	//C51зصĳȲԣC51ûе
	if(dwOutLen != 2)
	{
		printf("ETExecute Error 1:0x%08X\n",dwRet);
		delete [] pContext;
		return dwRet;
	}

	//Ҫ
	FlipBuffer((unsigned char*)pbOut, 2);
	memcpy(&res, pbOut, 2);


	printf("Result: %d\n",res);


	ETClose(&pContext[0]);
	delete [] pContext;
	
	return 0;
}
